package app

import (
	"bindbox-game/internal/pkg/logger"
	"bindbox-game/internal/repository/mysql"
	"bindbox-game/internal/repository/mysql/dao"
	"bindbox-game/internal/service/douyin"
	"bindbox-game/internal/service/sysconfig"
	tasksvc "bindbox-game/internal/service/task_center"
	usersvc "bindbox-game/internal/service/user"
)

type handler struct {
	logger  logger.CustomLogger
	writeDB *dao.Query
	readDB  *dao.Query
	user    usersvc.Service
	task    tasksvc.Service
	douyin  douyin.Service
	repo    mysql.Repo
}

func New(logger logger.CustomLogger, db mysql.Repo, taskSvc tasksvc.Service) *handler {
	syscfgSvc := sysconfig.New(logger, db)
	return &handler{
		logger:  logger,
		writeDB: dao.Use(db.GetDbW()),
		readDB:  dao.Use(db.GetDbR()),
		user:    usersvc.New(logger, db),
		task:    taskSvc,
		douyin:  douyin.New(logger, db, syscfgSvc, nil),
		repo:    db,
	}
}
